require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_IP_CONNTRACK_TUPLE_H)) {
    eval 'sub _IP_CONNTRACK_TUPLE_H () {1;}' unless defined(&_IP_CONNTRACK_TUPLE_H);
    require 'linux/types.ph';
    require 'linux/netfilter/nf_conntrack_tuple_common.ph';
    eval 'sub IP_CT_TUPLE_U_BLANK {
        my($tuple) = @_;
	    eval q( &do { ($tuple)-> ($src->{u}->{all}) = 0; ($tuple)-> ($dst->{u}->{all}) = 0; }  &while (0));
    }' unless defined(&IP_CT_TUPLE_U_BLANK);
    eval 'sub ip_ct_tuple_src_equal {
        my($t1,$t2) = @_;
	    eval q({  ($t1->{src}->{ip}) ==  ($t2->{src}->{ip})   &&  ($t1->{src}->{u}->{all}) ==  ($t2->{src}->{u}->{all}); });
    }' unless defined(&ip_ct_tuple_src_equal);
    eval 'sub ip_ct_tuple_dst_equal {
        my($t1,$t2) = @_;
	    eval q({  ($t1->{dst}->{ip}) ==  ($t2->{dst}->{ip})   &&  ($t1->{dst}->{u}->{all}) ==  ($t2->{dst}->{u}->{all})   &&  ($t1->{dst}->{protonum}) ==  ($t2->{dst}->{protonum}); });
    }' unless defined(&ip_ct_tuple_dst_equal);
    eval 'sub ip_ct_tuple_equal {
        my($t1,$t2) = @_;
	    eval q({  &ip_ct_tuple_src_equal($t1, $t2)  &&  &ip_ct_tuple_dst_equal($t1, $t2); });
    }' unless defined(&ip_ct_tuple_equal);
    eval 'sub ip_ct_tuple_mask_cmp {
        my($t,$tuple,$mask) = @_;
	    eval q({ !((( ($t->{src}->{ip}) ^  ($tuple->{src}->{ip})) &  ($mask->{src}->{ip})) || (( ($t->{dst}->{ip}) ^  ($tuple->{dst}->{ip})) &  ($mask->{dst}->{ip})) || (( ($t->{src}->{u}->{all}) ^  ($tuple->{src}->{u}->{all})) &  ($mask->{src}->{u}->{all})) || (( ($t->{dst}->{u}->{all}) ^  ($tuple->{dst}->{u}->{all})) &  ($mask->{dst}->{u}->{all})) || (( ($t->{dst}->{protonum}) ^  ($tuple->{dst}->{protonum})) &  ($mask->{dst}->{protonum}))); });
    }' unless defined(&ip_ct_tuple_mask_cmp);
}
1;
