require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_CONNTRACK_PROTO_GRE_H)) {
    eval 'sub _CONNTRACK_PROTO_GRE_H () {1;}' unless defined(&_CONNTRACK_PROTO_GRE_H);
    require 'asm/byteorder.ph';
    eval 'sub GRE_VERSION_1701 () {0x;}' unless defined(&GRE_VERSION_1701);
    eval 'sub GRE_VERSION_PPTP () {0x1;}' unless defined(&GRE_VERSION_PPTP);
    eval 'sub GRE_PROTOCOL_PPTP () {0x880b;}' unless defined(&GRE_PROTOCOL_PPTP);
    eval 'sub GRE_FLAG_C () {0x80;}' unless defined(&GRE_FLAG_C);
    eval 'sub GRE_FLAG_R () {0x40;}' unless defined(&GRE_FLAG_R);
    eval 'sub GRE_FLAG_K () {0x20;}' unless defined(&GRE_FLAG_K);
    eval 'sub GRE_FLAG_S () {0x10;}' unless defined(&GRE_FLAG_S);
    eval 'sub GRE_FLAG_A () {0x80;}' unless defined(&GRE_FLAG_A);
    eval 'sub GRE_IS_C {
        my($f) = @_;
	    eval q((($f) &GRE_FLAG_C));
    }' unless defined(&GRE_IS_C);
    eval 'sub GRE_IS_R {
        my($f) = @_;
	    eval q((($f) &GRE_FLAG_R));
    }' unless defined(&GRE_IS_R);
    eval 'sub GRE_IS_K {
        my($f) = @_;
	    eval q((($f) &GRE_FLAG_K));
    }' unless defined(&GRE_IS_K);
    eval 'sub GRE_IS_S {
        my($f) = @_;
	    eval q((($f) &GRE_FLAG_S));
    }' unless defined(&GRE_IS_S);
    eval 'sub GRE_IS_A {
        my($f) = @_;
	    eval q((($f) &GRE_FLAG_A));
    }' unless defined(&GRE_IS_A);
    if(defined( &__LITTLE_ENDIAN_BITFIELD)) {
    }
 elsif(defined( &__BIG_ENDIAN_BITFIELD)) {
    } else {
	die("Adjust your <asm/byteorder.h> defines");
    }
}
1;
